#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <sstream>
#include <complex>
#include <ctime>
#include <cassert>
#include <functional>

using namespace std;

typedef long long ll;
typedef vector<int> VI;
typedef pair<int,int> PII;

#define REP(i,s,t) for(int i=(s);i<(t);i++)
#define FILL(x,v) memset(x,v,sizeof(x))

const int INF = (int)1E9 + 5;
#define MAXN 200005
#define LOGN 17

int s[MAXN];
void add(int k, int v){
  k++;
  for(;k<MAXN;k+=-k&k) s[k]+=v;
}
int get(int k){
  if (k < 0) return 0;
  k++;
  int ans = 0;
  for(;k;k-=-k&k) ans += s[k];
  return ans;
}
int findkth(int k){
  int e = 0, cnt = 0;
  for(int i = LOGN; i >= 0; i--){
    int b = 1<<i;
    if(e+b>=MAXN || cnt+s[e+b]>=k) continue;
    e += b;
    cnt += s[e];
  }
  return e;
}

int n, p, q, S, A[MAXN], B[MAXN];
bool solve(int D, int S) {
  FILL(s, 0);
  REP(i,0,q) add(i, 1);
  int ans = 0;
  int lowD = q - 1, highD = q - 1, highS = q - 1;
  while (highS >= 0 && A[p - 1] + B[highS] > S) highS--;
  for (int i = p - 1; i >= 0; i--) {
    while (lowD >= 0 && A[i] - B[lowD] <= D) lowD--;
    while (highD >= 0 && B[highD] - A[i] > D) highD--;
    while (highS < q && A[i] + B[highS] <= S) highS++;
    int l = lowD + 1, r = min(highD, highS - 1);
    if (r < l) continue;
    int cnt = get(r) - get(l - 1);
    if (cnt == 0) continue;
    add(findkth(get(r)), -1);
    if (++ans >= n) return true;
  }
  return false;
}

int main() {
  cin >> n >> p >> q >> S;
  REP(i,0,p) cin >> A[i];
  REP(i,0,q) cin >> B[i];
  sort(A, A + p);
  sort(B, B + q);
  int l = 0, r = INF;
  while (l <= r) {
    int m = (l + r) / 2;
    if (solve(m, S)) r = m - 1;
    else l = m + 1;
  }
  cout << (l >= INF ? -1 : l) << endl;
  return 0;
}
