#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <sstream>
#include <complex>
#include <ctime>
#include <cassert>
#include <functional>

using namespace std;

typedef long long ll;
typedef vector<int> VI;
typedef pair<int,int> PII;

#define REP(i,s,t) for(int i=(s);i<(t);i++)
#define FILL(x,v) memset(x,v,sizeof(x))

const int INF = (int)1E9 + 5;
#define MAXN 200005
#define LOGN 17

int n, p, q, S, A[MAXN], B[MAXN];
int pre[MAXN], nxt[MAXN];
bool solve(int D, int S) {
  REP(i,0,q+2) {
    pre[i] = i - 1;
    nxt[i] = i + 1;
  }
  int ans = 0, lowD = q, highD = q, highS = q;
  while (highS >= 0 && A[p - 1] + B[highS] > S) highS = pre[highS];
  for (int i = p - 1; i >= 0; i--) {
    while (lowD > 0 && A[i] - B[lowD] <= D) lowD = pre[lowD];
    while (highD > 0 && B[highD] - A[i] > D) highD = pre[highD];
    while (highS <= q && A[i] + B[highS] <= S) highS = nxt[highS];
    int l = nxt[lowD], r = min(highD, pre[highS]);
    if (r < l) continue;
    if (lowD == r) lowD = pre[lowD];
    if (highD == r) highD = pre[highD];
    if (highS == r) highS = nxt[highS];
    nxt[pre[r]] = nxt[r];
    pre[nxt[r]] = pre[r];
    if (++ans >= n) return true;
  }
  return false;
}

int main() {
  cin >> n >> p >> q >> S;
  REP(i,0,p) cin >> A[i];
  REP(i,1,q+1) cin >> B[i];
  sort(A, A + p);
  sort(B + 1, B + 1 + q);
  int l = 0, r = INF;
  while (l <= r) {
    int m = (l + r) / 2;
    if (solve(m, S)) r = m - 1;
    else l = m + 1;
  }
  cout << (l >= INF ? -1 : l) << endl;
  return 0;
}
