import java.io.*;
import java.util.*;

public class icpccamp_tbuzzelli {

	static int n, na, nb, s, a[], b[];
	
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String[] tokens = br.readLine().split(" ");
		n = Integer.parseInt(tokens[0]);
		na = Integer.parseInt(tokens[1]);
		nb = Integer.parseInt(tokens[2]);
		s = Integer.parseInt(tokens[3]);
		a = new int[na];
		b = new int[nb];
		for (int i = 0; i < na; i++) a[i] = Integer.parseInt(br.readLine());
		for (int i = 0; i < nb; i++) b[i] = Integer.parseInt(br.readLine());
		
		TreeMap<Integer, Integer> originalTs = new TreeMap<>();
		for (int i : b) originalTs.put(i, originalTs.getOrDefault(i, 0) + 1);
		
		Arrays.sort(a);
		int min = 0, max = 1000000000;
		while (min < max) {
			int mid = (min + max) / 2;
			if (works(mid, originalTs)) {
				max = mid;
			} else {
				min = mid + 1;
			}
		}
		System.out.println(works(min, originalTs) ? min : -1);
	}
	
	static boolean works(int d, TreeMap<Integer, Integer> originalTs) {
		int count = 0;
		TreeMap<Integer, Integer> ts = new TreeMap<>(originalTs);
		
		// If we rebuild the TreeMap every time using this line, the entire solution would be 2.5x slow.
		// for (int i : b) ts.put(i, ts.getOrDefault(i, 0) + 1);
		
		for (int ai = na - 1; ai >= 0; ai--) {
			int x = a[ai];
			Integer tmp = ts.floorKey(Math.min(x + d, s - x));
			if (tmp == null) continue;
			int y = tmp;
			if (Math.abs(x - y) > d) continue;
			int cnt = ts.get(tmp) - 1;
			if (cnt == 0) ts.remove(tmp);
			else ts.put(tmp, cnt);
			++count;
			//if (count >= n) return true;
		}
		return count >= n;
	}
}
