#include <iostream>
#include <algorithm>
#include <vector>
#include <utility>

using namespace std;

// Templates from KACTL
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define trav(a, x) for(auto& a : x)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

bool find(int j, vector<vi>& g, vi& btoa, vi& vis) {
	if (btoa[j] == -1) return 1;
	vis[j] = 1; int di = btoa[j];
	trav(e, g[di])
		if (!vis[e] && find(e, g, btoa, vis)) {
			btoa[e] = di;
			return 1;
		}
	return 0;
}
int dfsMatching(vector<vi>& g, vi& btoa) {
	vi vis;
	rep(i,0,sz(g)) {
		vis.assign(sz(btoa), 0);
		trav(j,g[i])
			if (find(j, g, btoa, vis)) {
				btoa[j] = i;
				break;
			}
	}
	return sz(btoa) - (int)count(all(btoa), -1);
}

int main() {
	cin.sync_with_stdio(0); cin.tie(0);
	cin.exceptions(cin.failbit);

    int n, p, q;
    ll s;
    cin >> n >> p >> q >> s;
    vi a(p), b(q);
    for (auto& x : a)
        cin >> x;
    for (auto& y : b)
        cin >> y;

    sort(all(a));
    sort(all(b));

    constexpr int INF = 1e9 + 7;

    int lo = -1;
    int hi = INF;
    while (lo + 1 < hi) {
        int mid = lo + (hi - lo) / 2;
        vector<vi> graph(p);
        for (int i = 0; i < p; ++i) {
            for (int j = 0; j < q; ++j) {
                if (a[i] + b[j] > s) break;
                if (abs(a[i] - b[j]) <= mid) graph[i].push_back(j);
            }
        }

        vi res(q, -1);
        if (dfsMatching(graph, res) >= n) {
            hi = mid;
        } else {
            lo = mid;
        }
    }

    if (hi == INF)
        hi = -1;
    cout << hi << '\n';
}
